RangeHelp_curVer = "2.4";
RangeHelp_playerID = "";

-- command parameters
local UICOM = "ui"

local MAX_BAR = 120;

local TargetFrameState = 0;
local OldTargetFrameStat = 0;
local OutOfCombatLock = 0;
local mouse_x;
local mouse_y;

function RangeHelp_OnLoad()
	SlashCmdList["RANGEHELP"] = RangeHelp_SlashCommand;
	SLASH_RANGEHELP1 = "/rangehelp";
	SLASH_RANGEHELP2 = "/rh";
	
	RangeHelp_playerID = UnitName("player") .. " of " .. GetCVar("realmName");
	this:RegisterEvent("VARIABLES_LOADED");
	TargetFrameState = 0;
	OldTargetFrameState = 0;
end

function RangeHelp_OnEvent()
	if(event == "VARIABLES_LOADED") then
		if (not RangeConfig) then
			RangeConfig = {};
			RangeConfig["Version"] = RangeHelp_curVer;
		end
		if(not RangeConfig["Version"]) then
			RangeConfig["Version"] = "2.1";
			RangeConfig["hide rangeinfo"] = 0;
		end
		if(RangeConfig["Version"] == "2.1") then
			newRangeConfig = {};
			newRangeConfig[RangeHelp_playerID] = {};
			CopyTable(RangeConfig, newRangeConfig[RangeHelp_playerID]);
			RangeConfig = newRangeConfig;
			RangeConfig[RangeHelp_playerID]["enable rangehelp"] = 1;
			RangeConfig["Version"] = "2.2";
		end
		if(RangeConfig["Version"] == "2.2") then
			foreach(RangeConfig, function (k,v) if(type(v) == "table") then v["enable barswitch"] = 1 end end)
			RangeConfig["Version"] = "2.3";
		end
		RangeConfig["Version"] = RangeHelp_curVer;		
		if(not RangeConfig[RangeHelp_playerID]) then
			RangeConfig[RangeHelp_playerID] = {};
			RangeConfig[RangeHelp_playerID]["melee name"] = "wing clip";
--			RangeConfig[RangeHelp_playerID]["melee slot"] = -1;
			RangeConfig[RangeHelp_playerID]["range name"] = "auto shot";
--			RangeConfig[RangeHelp_playerID]["range slot"] = -1;
			RangeConfig[RangeHelp_playerID]["melee page"] = 2;
			RangeConfig[RangeHelp_playerID]["range page"] = 1;
			RangeConfig[RangeHelp_playerID]["lock"] = 1;
			RangeConfig[RangeHelp_playerID]["hide rangeinfo"] = 0;
			RangeConfig[RangeHelp_playerID]["enable barswitch"] = 1;
			local playerClass, englishClass = UnitClass("player");
			if(englishClass == "HUNTER") then
				RangeConfig[RangeHelp_playerID]["enable rangehelp"] = 1;
			else
				RangeConfig[RangeHelp_playerID]["enable rangehelp"] = 0;
			end
			RangeHelpUpdateSlot(0);
		end
--		this:RegisterEvent("ACTIONBAR_SLOT_CHANGED");		
--	elseif(event == "ACTIONBAR_SLOT_CHANGED") then
--		RangeHelpUpdateSlot(2);         	
	end
end

function RangeHelp_SlashCommand(msg)
	msg = string.lower(msg);
	
	cmd = strsub(msg, 1, 3);
	if(cmd == UICOM) then
		ShowUIPanel(RangeHelpUISetup);
	else
		ShowUIPanel(RangeHelpSetup);
	end
end

function RangeHelp_OnUpdate()
	if(RangeConfig[RangeHelp_playerID]["enable rangehelp"] == 0) then
		return;
	end
	if(UnitExists("target") and (not UnitIsDead("target")) and UnitCanAttack("player", "target")) then
		index = "";
		if(RangeConfig[RangeHelp_playerID]["hide rangeinfo"] == 0 and (not TargetRangeInfo:IsVisible())) then
			TargetRangeInfo:Show();
			RangeInfoFontFrame:SetScale(RangeHelpOption[RangeHelp_playerID]["font height"]);
		end
--		if(RangeConfig[RangeHelp_playerID]["melee slot"] == -1) then
		if(RangeConfig[RangeHelp_playerID]["melee name"] == "") then
			text = "melee not set";
			TargetRangeInfo:SetBackdropColor(1.0,1.0,1.0);
			TargetRangeInfo:SetBackdropBorderColor(1.0,1.0,1.0);
			TargetRange:SetTextColor(0.5,0.5,0.5);
			TargetRange:SetText(text);
--		elseif(RangeConfig[RangeHelp_playerID]["range slot"] == -1) then
		elseif(RangeConfig[RangeHelp_playerID]["range name"] == "") then
			text = "range not set";
			TargetRangeInfo:SetBackdropColor(1.0,1.0,1.0);
			TargetRangeInfo:SetBackdropBorderColor(1.0,1.0,1.0);
			TargetRange:SetTextColor(0.5,0.5,0.5);
			TargetRange:SetText(text);
--		elseif(IsActionInRange(RangeConfig[RangeHelp_playerID]["melee slot"]) == 1) then
		elseif(IsSpellInRange(RangeConfig[RangeHelp_playerID]["melee name"]) == 1) then
			if(RangeConfig[RangeHelp_playerID]["enable barswitch"] == 1) then
				if(RangeConfig[RangeHelp_playerID]["lock"] == 1) then
					if(GetActionBarPage()~= RangeConfig[RangeHelp_playerID]["melee page"]) then
						CURRENT_ACTIONBAR_PAGE = RangeConfig[RangeHelp_playerID]["melee page"];
						ChangeActionBarPage(CURRENT_ACTIONBAR_PAGE);
					end
				end
			end
			if(TargetFrameState ~= 1) then
				index = "melee ui";
				TargetFrameState = 1;
			end
		else
			if(RangeConfig[RangeHelp_playerID]["enable barswitch"] == 1) then
--				if(TargetFrameState == 1 or TargetFrameState == 0 or RangeConfig[RangeHelp_playerID]["lock"] == 1) then
				if(RangeConfig[RangeHelp_playerID]["lock"] == 1) then
					if(GetActionBarPage()~= RangeConfig[RangeHelp_playerID]["range page"] ) then
						CURRENT_ACTIONBAR_PAGE = RangeConfig[RangeHelp_playerID]["range page"];
						ChangeActionBarPage(CURRENT_ACTIONBAR_PAGE);
					end	
				end
			end
--			if(IsActionInRange(RangeConfig[RangeHelp_playerID]["range slot"]) == 1) then
			if(IsSpellInRange(RangeConfig[RangeHelp_playerID]["range name"]) == 1) then
				if(TargetFrameState ~= 2) then
					index = "range ui";
					TargetFrameState = 2;
				end
			elseif(CheckInteractDistance("target", 4)) then
				if(TargetFrameState ~= 3) then
					index = "dead ui";
					TargetFrameState = 3;
				end
			else
				if(TargetFrameState ~= 4) then
					index = "oorange ui";
					TargetFrameState = 4;
				end
			end
		end
		if(TargetFrameState ~= OldTargetFrameState) then
			TargetRangeInfo:SetBackdropColor(RangeHelpOption[RangeHelp_playerID][index].BGColor.r,
												RangeHelpOption[RangeHelp_playerID][index].BGColor.g,
												RangeHelpOption[RangeHelp_playerID][index].BGColor.b, 
												RangeHelpOption[RangeHelp_playerID][index].BGColor.alpha);
			TargetRangeInfo:SetBackdropBorderColor(RangeHelpOption[RangeHelp_playerID][index].BorColor.r,
													RangeHelpOption[RangeHelp_playerID][index].BorColor.g,
													RangeHelpOption[RangeHelp_playerID][index].BorColor.b,
													RangeHelpOption[RangeHelp_playerID][index].BorColor.alpha);
			TargetRange:SetTextColor(RangeHelpOption[RangeHelp_playerID][index].FontColor.r,
										RangeHelpOption[RangeHelp_playerID][index].FontColor.g,
										RangeHelpOption[RangeHelp_playerID][index].FontColor.b);
			TargetRange:SetText(RangeHelpOption[RangeHelp_playerID][index].Text);
			OldTargetFrameState = TargetFrameState;
		end
	else
		if(TargetRangeInfo:IsVisible() and RangeHelp_UISetup == 0) then
			TargetRangeInfo:Hide();
			if(RangeConfig[RangeHelp_playerID]["enable barswitch"] == 1) then
				if(GetActionBarPage() ~= RangeConfig[RangeHelp_playerID]["range page"]) then
					CURRENT_ACTIONBAR_PAGE = RangeConfig[RangeHelp_playerID]["range page"];
					ChangeActionBarPage(CURRENT_ACTIONBAR_PAGE);
				end
			end
			TargetFrameState = 0;
			OldTargetFrameState = 0;
			OutOfCombatLock = 0;
		elseif(RangeHelp_UISetup == 0 and OutOfCombatLock == 0) then
			if(RangeConfig[RangeHelp_playerID]["enable barswitch"] == 1) then
				if(GetActionBarPage() ~= RangeConfig[RangeHelp_playerID]["range page"]) then
					CURRENT_ACTIONBAR_PAGE = RangeConfig[RangeHelp_playerID]["range page"];
					ChangeActionBarPage(CURRENT_ACTIONBAR_PAGE);
					if(GetActionBarPage() == CURRENT_ACTIONBAR_PAGE) then
						OutOfCombatLock = 1;
					end
				end
			end
		end
	end
end

function RangeHelpUpdateSlot(print)
	success = 0;
	melee = 0;
	range = 0;
	
--	mname = string.lower(RangeConfig[RangeHelp_playerID]["melee name"]);
--	rname = string.lower(RangeConfig[RangeHelp_playerID]["range name"]);
--	RangeHelpActionTip:SetOwner(WorldFrame,"ANCHOR_NONE"); 
--	for slot=1, MAX_BAR do
--		RangeHelpActionTip:SetAction(slot);
--		name = RangeHelpActionTipTextLeft1:GetText();
--		if(name ~= nil) then
--			nname = string.lower(name);
--			if(nname == mname) then
--				RangeConfig[RangeHelp_playerID]["melee name"] = name;
--				RangeConfig[RangeHelp_playerID]["melee slot"] = slot;
--				melee = 1;
--			elseif(nname == rname) then
--				RangeConfig[RangeHelp_playerID]["range name"] = name;
--				RangeConfig[RangeHelp_playerID]["range slot"] = slot;
--				range = 1;
--			end
--			if(melee == 1 and range == 1) then
--			   break
--			end
--		end
--	end

	mname = string.lower(RangeConfig[RangeHelp_playerID]["melee name"]);
	rname = string.lower(RangeConfig[RangeHelp_playerID]["range name"]);
    local i = 1
    while true do
		local spellName, spellRank = GetSpellName(i, BOOKTYPE_SPELL)
		if not spellName then
			do break end
		end
		nname = string.lower(spellName);
		if(nname == mname) then
			RangeConfig[RangeHelp_playerID]["melee name"] = spellName;
			melee = 1;
		elseif(nname == rname) then
			RangeConfig[RangeHelp_playerID]["range name"] = spellName;
			range = 1;
		end
		if(melee == 1 and range == 1) then
			break
		end
   
		i = i + 1
	end

	if(print == 0) then
		if(melee == 0) then
			RangeConfig[RangeHelp_playerID]["melee name"] = "";
		end
		if(range == 0) then
			RangeConfig[RangeHelp_playerID]["range name"] = "";
		end
	elseif(print == 1) then
		errStr = "";
		if(melee == 0) then
			errStr = errStr.."Unable to find melee spell '"..RangeConfig[RangeHelp_playerID]["melee name"].."'. ";
			RangeConfig[RangeHelp_playerID]["melee name"] = "";
			RangeConfig[RangeHelp_playerID]["melee slot"] = -1;
		end
		if(range == 0) then
			errStr = errStr.."Unable to find range spell '"..RangeConfig[RangeHelp_playerID]["range name"].."'. ";
			RangeConfig[RangeHelp_playerID]["range name"] = "";
			RangeConfig[RangeHelp_playerID]["range slot"] = -1;
		end
		if(errStr ~= "") then
			_ERRORMESSAGE(errStr);
		else
			success = 1;
		end
	elseif(print == 2) then
		if(melee == 0) then
			RangeConfig[RangeHelp_playerID]["melee slot"] = -1;
		end
		if(range == 0) then
			RangeConfig[RangeHelp_playerID]["range slot"] = -1;
		end
	end
	return success;
end

function RangeHelp_Echo(msg)
	DEFAULT_CHAT_FRAME:AddMessage(msg);
end

function RangeHelp_OnDragStart()
	if(RangeHelpOption[RangeHelp_playerID]["resize"] == 1) then
		local hotleft = TargetRangeInfo:GetLeft()*UIParent:GetScale() + 7;
		local hottop = TargetRangeInfo:GetTop()*UIParent:GetScale() - 7;
		local hotbottom = TargetRangeInfo:GetBottom()*UIParent:GetScale() + 7;
		local hotright = TargetRangeInfo:GetRight()*UIParent:GetScale() - 7;
		if(mouse_x < hotleft and mouse_y > hottop) then
			TargetRangeInfo:StartSizing("TOPLEFT");
		elseif(mouse_x > hotright and mouse_y > hottop) then
			TargetRangeInfo:StartSizing("TOPRIGHT");
		elseif(mouse_x > hotright and mouse_y < hotbottom) then
			TargetRangeInfo:StartSizing("BOTTOMRIGHT");
		elseif(mouse_x < hotleft and mouse_y < hotbottom) then
			TargetRangeInfo:StartSizing("BOTTOMLEFT");
		elseif(mouse_x > hotright) then
			TargetRangeInfo:StartSizing("RIGHT");
		elseif(mouse_x < hotleft) then
			TargetRangeInfo:StartSizing("LEFT");
		elseif(mouse_y > hottop) then
			TargetRangeInfo:StartSizing("TOP");
		elseif(mouse_y < hotbottom) then
			TargetRangeInfo:StartSizing("BOTTOM");
		elseif(RangeHelpOption[RangeHelp_playerID]["move"] == 1) then
			TargetRangeInfo:StartMoving();
		end
	elseif(RangeHelpOption[RangeHelp_playerID]["move"] == 1) then
		TargetRangeInfo:StartMoving();
	end
end

function RangeHelp_OnDragStop()
	TargetRangeInfo:StopMovingOrSizing();
end

function RangeHelp_OnMouseDown()
	mouse_x, mouse_y = GetCursorPosition();
end